/**
 * $Id: filedlg.c,v 1.2 2001/05/16 21:37:57 makki Exp $
 * $Author: makki $
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#ifdef HAVE_GNOME
#include <gnome.h>
#endif
#include <gnome-xml/tree.h>
#include <glade/glade.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"

void filedlg_ok_callback( GtkWidget *widget, char** data );


GtkWidget*
filedlg_new(){
	GladeXML* xml = glade_xml_new(GLADE_UI_FILE,"filesaveas");
	GtkWidget *widget;
	if( xml == NULL ){
		g_print("ERROR: filesaveas not found in %s\n",GLADE_UI_FILE);
		return NULL;
	}
	glade_xml_signal_autoconnect(xml);
	widget = glade_xml_get_widget(xml,"filesaveas");
	if( widget == NULL ){
		g_print("ERROR: filesaveas could not be created from %s\n", GLADE_UI_FILE);
		return NULL;
	}
	return widget;
}

/** Returns NULL when cancel
 * Returns a str which is up to you to destroy
 */

char*
filedlg_show( GtkWidget* widget, char* filename ){
	if( filename != NULL ){
		gtk_file_selection_set_filename( GTK_FILE_SELECTION(widget), filename );
	}
	gtk_signal_connect(GTK_OBJECT(GTK_FILE_SELECTION(widget)->ok_button), 
                           "clicked", filedlg_ok_callback, &filename);
	gtk_widget_show(widget);
	gtk_main();
	gtk_widget_hide(widget);
	return filename;
}
void
filedlg_ok_callback( GtkWidget *widget, char** n ){
	GtkWidget* s = gtk_widget_get_toplevel(widget);
	*n = strdup(gtk_file_selection_get_filename( GTK_FILE_SELECTION(s)));
	gtk_main_quit();
}
