#ifndef __GTKEDITOR_H__
#define __GTKEDITOR_H__

#include <gtk/gtkhbox.h>
#include <gtk/gtkentry.h>
#include <gnome-xml/tree.h>

#include "gtkxmlview.h"
#include "gtkxmlcontainer.h"

#ifdef __cplusplus
extern "C" {
#endif


#define TYPE_GTK_XML_EDITOR				(gtk_xml_editor_get_type())
#define GTK_XML_EDITOR(obj)				(GTK_CHECK_CAST((obj),TYPE_GTK_XML_EDITOR, GtkXmlEditor))
#define GTK_XML_EDITOR_CLASS(klass)		(GTK_CHECK_CLASS_CAST((klass), TYPE_GTK_XML_EDITOR, GtkXmlEditorClass))
#define IS_GTK_XML_EDITOR(obj)			(GTK_CHECK_TYPE((obj), TYPE_GTK_XML_EDITOR))
#define IS_GTK_XML_EDITOR_CLASS(klass)	(GTK_CHECK_CLASS_TYPE((klass), TYPE_GTK_XML_EDITOR))


typedef struct _GtkXmlEditor GtkXmlEditor;
typedef struct _GtkXmlEditorClass GtkXmlEditorClass;

struct _GtkXmlEditor{
	GtkHBox box;
	GtkXmlView *tree;
	gpointer private_data;
};

struct _GtkXmlEditorClass{
	GtkHBoxClass parent_class;
	
	void (*changed) (GtkXmlEditor* editor, gpointer data);
	void (*view_changed) (GtkXmlEditor* editor, gpointer data );
};

GtkWidget* gtk_xml_editor_new(GtkXmlContainer* container );
//GtkWidget* gtk_xml_editor_new_from_tree( GtkXmlTree *tree );

xmlDoc* gtk_xml_editor_get_document( GtkXmlEditor* editor );
xmlDoc* gtk_xml_editor_set_document( GtkXmlEditor *editor, xmlDoc* doc );
xmlNode* gtk_xml_editor_get_current_node( GtkXmlEditor* editor );

GtkXmlView* gtk_xml_editor_get_view( GtkXmlEditor* editor );
void gtk_xml_editor_set_view( GtkXmlEditor* editor, GtkXmlView* view );

#ifdef __cplusplus
}
#endif

#endif
