#ifndef __GTKXMLMODULES_H__
#define __GTKXMLMODULES_H__

#include <stdio.h>
#include <gmodule.h>
#include <gtk/gtk.h>
#include <gnome-xml/tree.h>

#include "modules.h"

#ifdef __cplusplus
extern "C" {
#endif

#define TYPE_GTK_XML_MODULES			(gtk_xml_modules_get_type())
#define GTK_XML_MODULES(obj)			(GTK_CHECK_CAST((obj),TYPE_GTK_XML_MODULES, GtkXmlModules))
#define GTK_XML_MODULES_CLASS(klass)	(GTK_CHECK_CLASS_CAST((klass), TYPE_GTK_XML_MODULES, GtkXmlModulesClass))
#define IS_GTK_XML_MODULES(obj)		(GTK_CHECK_TYPE((obj), TYPE_GTK_XML_MODULES))
#define IS_GTK_XML_MODULES_CLASS(klass)	(GTK_CHECK_CLASS_TYPE((klass), TYPE_GTK_XML_MODULES))

typedef struct _GtkXmlModules GtkXmlModules;
typedef struct _GtkXmlModulesClass GtkXmlModulesClass;

struct _GtkXmlModules{
	GtkObject super;
	GHashTable* table;
	GList* list;
	gpointer private_data;
};

struct _GtkXmlModulesClass{
	GtkObjectClass parent_class;
	
	void (*add_module) (GtkXmlModules* modules, gpointer data );
	void (*remove_module) (GtkXmlModules* modules, gpointer data );
	void (*enable_module) (GtkXmlModules* modules, gpointer data );
	void (*disable_module) (GtkXmlModules* modules, gpointer data );
};

GtkObject* gtk_xml_modules_new();
void gtk_xml_modules_enable( GtkXmlModules* m, const gchar* name );
void gtk_xml_modules_disable( GtkXmlModules* m, const gchar* name );
GModule* gtk_xml_modules_get_module( GtkXmlModules* m, const gchar* name);
gboolean gtk_xml_modules_add_module( GtkXmlModules* m, const gchar* filename );

void gtk_xml_modules_load_list( GtkXmlModules* m, xmlDoc* doc );
void gtk_xml_modules_save_list( GtkXmlModules* m, FILE* f);
GList* gtk_xml_modules_get_module_names( GtkXmlModules* m );

ModuleInfo* gtk_xml_modules_get_module_info( GtkXmlModules* modules, const gchar* name );

gboolean gtk_xml_modules_is_import( GtkXmlModules* modules, const gchar* name );
gboolean gtk_xml_modules_is_export( GtkXmlModules* modules, const gchar* name );
gboolean gtk_xml_modules_is_editor( GtkXmlModules* modules, const gchar* name );
gboolean gtk_xml_modules_is_view( GtkXmlModules* modules, const gchar* name );

GtkWidget* gtk_xml_modules_get_configuration( GtkXmlModules* m );


#ifdef __cplusplus
}
#endif

#endif
