#ifndef __GTKVIEW_H__
#define __GTKVIEW_H__

#include <gtk/gtkhbox.h>
#include <gtk/gtkentry.h>
#include <gnome-xml/tree.h>

#ifdef __cplusplus
extern "C" {
#endif


#define TYPE_GTK_XML_VIEW				(gtk_xml_view_get_type())
#define GTK_XML_VIEW(obj)				(GTK_CHECK_CAST((obj),TYPE_GTK_XML_VIEW, GtkXmlView))
#define GTK_XML_VIEW_CLASS(klass)		(GTK_CHECK_CLASS_CAST((klass), TYPE_GTK_XML_VIEW, GtkXmlViewClass))
#define IS_GTK_XML_VIEW(obj)			(GTK_CHECK_TYPE((obj), TYPE_GTK_XML_VIEW))
#define IS_GTK_XML_VIEW_CLASS(klass)	(GTK_CHECK_CLASS_TYPE((klass), TYPE_GTK_XML_VIEW))


typedef struct _GtkXmlView GtkXmlView;
typedef struct _GtkXmlViewClass GtkXmlViewClass;

struct _GtkXmlView{
	GtkHBox box;
	xmlDoc* doc;
	xmlNode* selected;
	gpointer private_data;
};

struct _GtkXmlViewClass{
	GtkHBoxClass parent_class;
	
	void (*update_node) (GtkXmlView* view, gpointer data);
	void (*select_node) (GtkXmlView* view, gpointer data);
	void (*unselect_node) (GtkXmlView* view, gpointer data);
	void (*clicked) (GtkXmlView* view, gpointer data);
	void (*doubleclicked) (GtkXmlView* view, gpointer data);
	void (*append_child_node) (GtkXmlView* view, gpointer data);
	void (*delete_node) (GtkXmlView* view, gpointer data);
};

GtkWidget* gtk_xml_view_new(xmlDoc* doc);

xmlDoc* gtk_xml_view_get_document( GtkXmlView* view );
void gtk_xml_view_add_attribute( GtkXmlView* view, xmlNode* node, gchar* attrname, gchar* attrvalue );
void gtk_xml_view_update_attribute( GtkXmlView* view, xmlNode* node, gchar* attrname, gchar* attrvalue );
void gtk_xml_view_select_node( GtkXmlView* view, xmlNode *node);
void gtk_xml_view_unselect_node( GtkXmlView* view, xmlNode *node);
xmlNode* gtk_xml_view_get_selected_node( GtkXmlView* view );
#ifdef __cplusplus
}
#endif

#endif
