/**
 * $Id: newdlg.c,v 1.2 2001/05/16 21:37:57 makki Exp $
 * $Author: makki $
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#ifdef HAVE_GNOME
#include <gnome.h>
#endif
#include <gnome-xml/tree.h>
#include <glade/glade.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"
#include "gtkxmlcontainer.h"

static void newdlg_ok_callback( GtkWidget *widget, xmlDoc** data );


GtkWidget*
newdlg_new( GtkXmlContainer* container ){
	GladeXML* xml = glade_xml_new(GLADE_UI_FILE,"new");
	GtkWidget *widget;
	GtkWidget *w;
	g_assert(container);
	if( xml == NULL ){
		return NULL;
	}
	glade_xml_signal_autoconnect(xml);
	widget = glade_xml_get_widget(xml,"new");
	if( widget == NULL ){
		return NULL;
	}
	w = glade_xml_get_widget( xml, "doctypecombo" );
	if( w != NULL ){
		GList* strings = NULL;
		GtkXmlModules* m = gtk_xml_container_get_modules( container );
		GList* names;
		gchar** pars;
		char* value;
		if( m == NULL ){
			return widget;
		}
		names = gtk_xml_modules_get_module_names(m);
		while( names != NULL ){
			int i=0;
			pars = mod_get_attributes( gtk_xml_modules_get_module_info( m, names->data ), "doctype");
			while( pars[i] != NULL ){
				strings = g_list_append(strings, pars[i] );
				i++;
			}
			names = g_list_next(names);
		}
		if( strings != NULL ){
			gtk_combo_set_popdown_strings( GTK_COMBO(w), strings );
		}
	}
	gtk_object_set_user_data( GTK_OBJECT(widget), xml );
	return widget;
}

/** Returns NULL when cancel
 * Returns a str which is up to you to destroy
 */

xmlDoc*
newdlg_show( GtkWidget* widget ){
	GtkWidget* w;
	xmlDoc* doc = NULL;
	GladeXML* xml;
	xml = (GladeXML*)( gtk_object_get_user_data(widget) );
	w = glade_xml_get_widget(xml,"create");
	if( w != NULL ){
		gtk_object_set_user_data( GTK_OBJECT(w), xml );
		gtk_signal_connect(GTK_OBJECT(w), "clicked", newdlg_ok_callback, &doc);
	}
	gtk_widget_show(widget);
	gtk_main();
	gtk_widget_hide(widget);
	return doc;
}

static void
newdlg_ok_callback( GtkWidget *widget, xmlDoc** doc ){
	char* str1;
	char* str2 = NULL;
	char* str3 = NULL;
	char** array;
	GladeXML* xml = (GladeXML*)gtk_object_get_user_data( GTK_OBJECT(widget) );
	GtkWidget* w;
	w = glade_xml_get_widget(xml, "doctype");
	str1 = gtk_entry_get_text( GTK_ENTRY(w) );
	if( strlen(str1) > 0 ){
		array = g_strsplit(str1, " ", 3 );
		str1 = array[0];
		if( str1 != NULL ){
			str2 = array[1];
			if( str2 != NULL ){
				str3 = array[2];
			}
		}
		*doc = xmlNewDoc("1.0");
		((xmlNode*)*doc)->xmlChildrenNode = xmlNewDocNode(*doc, NULL, "Untitled", NULL );
		xmlCreateIntSubset( *doc, array[0], array[1], array[2] );
//		(*doc)->intSubset = xmlNewDtd(doc, array[0], array[1], array[2] );
		gtk_main_quit();
	}
}
